From 644ee52e48dffd7f9d90d839f9cb3f9acfc7a18b Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Mon, 15 Apr 2019 11:45:41 +0200
Subject: [PATCH] fonts: add Poppins (#32279)

---
 README                                        |   7 +++++
 .../fonts/Poppins/poppins-black-webfont.woff  | Bin 0 -> 22592 bytes
 .../fonts/Poppins/poppins-black-webfont.woff2 | Bin 0 -> 17100 bytes
 .../Poppins/poppins-blackitalic-webfont.woff  | Bin 0 -> 23968 bytes
 .../Poppins/poppins-blackitalic-webfont.woff2 | Bin 0 -> 18128 bytes
 .../fonts/Poppins/poppins-bold-webfont.woff   | Bin 0 -> 23664 bytes
 .../fonts/Poppins/poppins-bold-webfont.woff2  | Bin 0 -> 17908 bytes
 .../Poppins/poppins-bolditalic-webfont.woff   | Bin 0 -> 25232 bytes
 .../Poppins/poppins-bolditalic-webfont.woff2  | Bin 0 -> 19108 bytes
 .../Poppins/poppins-extrabold-webfont.woff    | Bin 0 -> 23144 bytes
 .../Poppins/poppins-extrabold-webfont.woff2   | Bin 0 -> 17064 bytes
 .../poppins-extrabolditalic-webfont.woff      | Bin 0 -> 25292 bytes
 .../poppins-extrabolditalic-webfont.woff2     | Bin 0 -> 19132 bytes
 .../Poppins/poppins-extralight-webfont.woff   | Bin 0 -> 23624 bytes
 .../Poppins/poppins-extralight-webfont.woff2  | Bin 0 -> 18060 bytes
 .../poppins-extralightitalic-webfont.woff     | Bin 0 -> 26600 bytes
 .../poppins-extralightitalic-webfont.woff2    | Bin 0 -> 20528 bytes
 .../fonts/Poppins/poppins-light-webfont.woff  | Bin 0 -> 23392 bytes
 .../fonts/Poppins/poppins-light-webfont.woff2 | Bin 0 -> 17384 bytes
 .../Poppins/poppins-lightitalic-webfont.woff  | Bin 0 -> 26216 bytes
 .../Poppins/poppins-lightitalic-webfont.woff2 | Bin 0 -> 19760 bytes
 .../fonts/Poppins/poppins-medium-webfont.woff | Bin 0 -> 23288 bytes
 .../Poppins/poppins-medium-webfont.woff2      | Bin 0 -> 17252 bytes
 .../Poppins/poppins-mediumitalic-webfont.woff | Bin 0 -> 25904 bytes
 .../poppins-mediumitalic-webfont.woff2        | Bin 0 -> 19748 bytes
 .../Poppins/poppins-regular-webfont.woff      | Bin 0 -> 23224 bytes
 .../Poppins/poppins-regular-webfont.woff2     | Bin 0 -> 17224 bytes
 .../poppins-regularitalic-webfont.woff        | Bin 0 -> 26096 bytes
 .../poppins-regularitalic-webfont.woff2       | Bin 0 -> 20036 bytes
 .../Poppins/poppins-semibold-webfont.woff     | Bin 0 -> 23748 bytes
 .../Poppins/poppins-semibold-webfont.woff2    | Bin 0 -> 17576 bytes
 .../poppins-semibolditalic-webfont.woff       | Bin 0 -> 25968 bytes
 .../poppins-semibolditalic-webfont.woff2      | Bin 0 -> 19828 bytes
 .../fonts/Poppins/poppins-thin-webfont.woff   | Bin 0 -> 23184 bytes
 .../fonts/Poppins/poppins-thin-webfont.woff2  | Bin 0 -> 17796 bytes
 .../Poppins/poppins-thinitalic-webfont.woff   | Bin 0 -> 26572 bytes
 .../Poppins/poppins-thinitalic-webfont.woff2  | Bin 0 -> 20332 bytes
 static/includes/_font-poppins.scss            |  24 ++++++++++++++++++
 38 files changed, 31 insertions(+)
 create mode 100644 static/fonts/Poppins/poppins-black-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-black-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-blackitalic-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-blackitalic-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-bold-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-bold-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-bolditalic-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-bolditalic-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-extrabold-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-extrabold-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-extrabolditalic-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-extrabolditalic-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-extralight-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-extralight-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-extralightitalic-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-extralightitalic-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-light-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-light-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-lightitalic-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-lightitalic-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-medium-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-medium-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-mediumitalic-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-mediumitalic-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-regular-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-regular-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-regularitalic-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-regularitalic-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-semibold-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-semibold-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-semibolditalic-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-semibolditalic-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-thin-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-thin-webfont.woff2
 create mode 100644 static/fonts/Poppins/poppins-thinitalic-webfont.woff
 create mode 100644 static/fonts/Poppins/poppins-thinitalic-webfont.woff2
 create mode 100644 static/includes/_font-poppins.scss

diff --git a/README b/README
index 4c7d87a7..94d022d5 100644
--- a/README
+++ b/README
@@ -157,6 +157,13 @@ copyright notices:
   #
   # https://www.fontsquirrel.com/license/cabin
 
+* Poppins
+  # Copyright (c) 2014, Indian Type Foundry (info@indiantypefoundry.com).
+  #
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1
+  #
+  # https://www.fontsquirrel.com/license/poppins
+
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
diff --git a/static/fonts/Poppins/poppins-black-webfont.woff b/static/fonts/Poppins/poppins-black-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..f3d19683ec230bcc74585a5f2521ce5a8d96f365
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-black-webfont.woff2 b/static/fonts/Poppins/poppins-black-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..c626a5255df413fc13155d039c37cba9e6b34bc6
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-blackitalic-webfont.woff b/static/fonts/Poppins/poppins-blackitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..68e10ee9a15cc5bd5b08062b4463c7538b756f45
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-blackitalic-webfont.woff2 b/static/fonts/Poppins/poppins-blackitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..d48a5ba2c7f4617ce6c120ac8ff445e328e9dc60
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-bold-webfont.woff b/static/fonts/Poppins/poppins-bold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..5541c2b24edcc94f6e4fec76651b453fd9bee8ee
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-bold-webfont.woff2 b/static/fonts/Poppins/poppins-bold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..3f308f7944373fc1347c3ba510224534910018bd
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-bolditalic-webfont.woff b/static/fonts/Poppins/poppins-bolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..2a25d05e91503a6d4a07ef2e524b1e2dc5009132
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-bolditalic-webfont.woff2 b/static/fonts/Poppins/poppins-bolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..9aa83591443ed6b1c6414af94937136b066b4b0e
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-extrabold-webfont.woff b/static/fonts/Poppins/poppins-extrabold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..d1cc19e0105bc66a93d9b11aa79049531e2be616
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-extrabold-webfont.woff2 b/static/fonts/Poppins/poppins-extrabold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..4f1c0b67a03807743992e3b8c0e4a108e2dc6eb5
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-extrabolditalic-webfont.woff b/static/fonts/Poppins/poppins-extrabolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..af2a6ee598cdc85a45c45f2ea78c92044e762258
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-extrabolditalic-webfont.woff2 b/static/fonts/Poppins/poppins-extrabolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..34aaf7974ddb1812f9d8e15f50f26d1257e7e097
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-extralight-webfont.woff b/static/fonts/Poppins/poppins-extralight-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..72386f06ba2f5251dda1a34ed0612d381b91d1a8
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-extralight-webfont.woff2 b/static/fonts/Poppins/poppins-extralight-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..6a8d7b0f8739e9724c8dc99bd5e6f9afb9450c53
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-extralightitalic-webfont.woff b/static/fonts/Poppins/poppins-extralightitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..dd498ca436c7dc3fbcaea09dfbe0971561e8a201
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-extralightitalic-webfont.woff2 b/static/fonts/Poppins/poppins-extralightitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..d2128d3095f0f45598f925514beb8f2f5942a4a1
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-light-webfont.woff b/static/fonts/Poppins/poppins-light-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..0ce1b6adcda791de0ff5769c35907de5df107357
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-light-webfont.woff2 b/static/fonts/Poppins/poppins-light-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..63ca1dfa7dac5a71ffeb9e61a50e8751917e1740
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-lightitalic-webfont.woff b/static/fonts/Poppins/poppins-lightitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..ae705e78e0c90f95740a5b8e076486ed1b548d97
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-lightitalic-webfont.woff2 b/static/fonts/Poppins/poppins-lightitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..a495bcef9caad24ba883f4db77e303dd0da96dc4
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-medium-webfont.woff b/static/fonts/Poppins/poppins-medium-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..dd725283129d925208fc9613cfcbcf727b7357c5
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-medium-webfont.woff2 b/static/fonts/Poppins/poppins-medium-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..f2e0a37919d8cd3362fabc6a6efeb847ba05a836
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-mediumitalic-webfont.woff b/static/fonts/Poppins/poppins-mediumitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..0b3de7c152bbc638bdcd6d8c7f22fd8532b557ee
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-mediumitalic-webfont.woff2 b/static/fonts/Poppins/poppins-mediumitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..1fbdbfe1a5ef4736a553e4c6347c4cc018354916
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-regular-webfont.woff b/static/fonts/Poppins/poppins-regular-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..dd42e0bcd8db9914b4674eccb6466da79533b208
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-regular-webfont.woff2 b/static/fonts/Poppins/poppins-regular-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..fccac0f4b80657b66d4cca3940306e90acb753c9
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-regularitalic-webfont.woff b/static/fonts/Poppins/poppins-regularitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..35d2ac07162b3f214e66a1bde999fdc478fa5bdb
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-regularitalic-webfont.woff2 b/static/fonts/Poppins/poppins-regularitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..c65c3c751fdfa6dd47c7f9b426f6a2c3669526f2
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-semibold-webfont.woff b/static/fonts/Poppins/poppins-semibold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..f1a7d0231eda2cec8fc033651cc98ba2f8c63865
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-semibold-webfont.woff2 b/static/fonts/Poppins/poppins-semibold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..a10413235b2f0fb1ab8c25fb97f1aa30dbb64217
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-semibolditalic-webfont.woff b/static/fonts/Poppins/poppins-semibolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..93599aa986c151a74eac95597dc0c7d63be6b82a
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-semibolditalic-webfont.woff2 b/static/fonts/Poppins/poppins-semibolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..7410b4995aa4efb23379f07aa22c6cadd201862c
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-thin-webfont.woff b/static/fonts/Poppins/poppins-thin-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..699416e3a214304351d11ef74a82f14a4ef9be97
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-thin-webfont.woff2 b/static/fonts/Poppins/poppins-thin-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..d058c5a5a7ca9575ce82d464b1fb21fe84505cc0
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-thinitalic-webfont.woff b/static/fonts/Poppins/poppins-thinitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..227e4dac6cb5e6bbb011490b5bf4c2ca0fdaacad
GIT binary patch
diff --git a/static/fonts/Poppins/poppins-thinitalic-webfont.woff2 b/static/fonts/Poppins/poppins-thinitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..2af5fef075f326c9d73ea0dd7158356dd29bc1b0
GIT binary patch
diff --git a/static/includes/_font-poppins.scss b/static/includes/_font-poppins.scss
new file mode 100644
index 00000000..357aa329
--- /dev/null
+++ b/static/includes/_font-poppins.scss
@@ -0,0 +1,24 @@
+@mixin poppins-font($type, $weight, $style) {
+	@font-face {
+		font-family: 'Poppins';
+		src: url('../fonts/Poppins/poppins-#{$type}-webfont.woff2') format('woff2'),
+		     url('../fonts/Poppins/poppins-#{$type}-webfont.woff') format('woff');
+		font-weight: $weight;
+		font-style: $style;
+	}
+}
+
+@mixin poppins-font-pair($type, $weight) {
+	@include poppins-font($type, $weight, normal);
+	@include poppins-font('#{$type}italic', $weight, italic);
+}
+
+@include poppins-font-pair('thin', 100);
+@include poppins-font-pair('extralight', 200);
+@include poppins-font-pair('light', 300);
+@include poppins-font-pair('regular', 400);
+@include poppins-font-pair('medium', 500);
+@include poppins-font-pair('semibold', 600);
+@include poppins-font-pair('bold', 700);
+@include poppins-font-pair('extrabold', 800);
+@include poppins-font-pair('black', 900);
-- 
2.20.1