From 5cb21d5f365745ce7b8cb3f3b12c8d97ab9ed7c0 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Thu, 18 Apr 2019 09:02:26 +0200
Subject: [PATCH] help: shuffle api-fill.page for better formatting (#32434)

---
 help/fr/api-fill.page | 210 ++++++++++++++++++++++--------------------
 1 file changed, 110 insertions(+), 100 deletions(-)

diff --git a/help/fr/api-fill.page b/help/fr/api-fill.page
index ac8c8e413..ae83c0bce 100644
--- a/help/fr/api-fill.page
+++ b/help/fr/api-fill.page
@@ -48,107 +48,10 @@ formulaire existant.
 
   <item>
   <p>
-   Les champs de type « Liste » acceptent différentes valeurs selon leur
-   configuration.
+   Les champs de type « Liste » et « Liste à choix multiples » acceptent
+   différentes valeurs selon leur configuration, ceci est décrit dans
+   <link xref="#fill-list"/>.
   </p>
-  <terms>
-    <item>
-    <title>liste simple</title>
-    <p>La valeur doit être une chaîne tirée de la liste.</p>
-    <listing>
-    <code>
-    "data": {
-       "<var>varname</var>": "Libellé 1",
-    }
-    </code>
-    </listing>
-    </item>
-    <item>
-    <title>source de donnée</title>
-    <p>La valeur peut être l'identifiant d'une donnée structurée ou si la
-    donnée structurée complète est transmise, l'identifiant de la donnée dans
-    une clé suffixée de <code>_raw</code>, le libellé de la donnée dans la clé
-    normale et éventuellement la donnée structurée complète dans une clé
-    suffixée de <code>_structured</code></p>
-    <listing>
-    <code>
-    "data": {
-       "<var>varname</var>": "1"
-    }
-    </code>
-    </listing>
-    <listing>
-    <code>
-    "data": {
-       "<var>varname</var>": "Libellé 1",
-       "<var>varname</var>_raw": "1",
-       "<var>varname</var>_structured": {
-          "id": "1",
-          "text": "Libellé 1",
-          "foo": "bar"
-       }
-    }
-    </code>
-    </listing>
-    </item>
-  </terms>
-  </item>
-
-
-  <item>
-  <p>
-   Les champs de type « Liste à choix multiple » acceptent différentes valeurs
-   selon leur configuration.
-  </p>
-  <terms>
-    <item>
-    <title>liste simple</title>
-    <p>La valeur doit être une liste de chaînes tirée de la liste.</p>
-    <listing>
-    <code>
-    "data": {
-       "<var>varname</var>": ["Libellé 1", "Libellé 2"],
-    }
-    </code>
-    </listing>
-    </item>
-    <item>
-    <title>source de donnée</title>
-    <p>La valeur peut être une liste d'identifiants d'une donnée structurée ou
-    si la donnée structurée complète est transmise, la liste des identifiants
-    de la donnée dans une clé suffixée de <code>_raw</code>, la liste des
-    libellés de la donnée dans la clé normale et éventuellement la liste des
-    données structurées complètes dans une clé suffixée de
-    <code>_structured</code></p>
-    <listing>
-    <code>
-    "data": {
-       "<var>varname</var>": ["1", "2"]
-    }
-    </code>
-    </listing>
-    <listing>
-    <code>
-    "data": {
-       "<var>varname</var>": ["Libellé 1", "Libellé 2"],
-       "<var>varname</var>_raw": ["1", "2"],
-       "<var>varname</var>_structured": [
-         {
-            "id": "1",
-            "text": "Libellé 1",
-            "foo": "bar"
-         },
-         {
-            "id": "2",
-            "text": "Libellé 2",
-            "foo": "bar2"
-         }
-       ]
-    }
-    </code>
-    </listing>
-    </item>
-  </terms>
   </item>
 
   <item>
@@ -274,4 +177,111 @@ formulaire existant.
 
 </section>
 
+<section id="fill-list">
+  <title>Transmission des champs « Liste » et « Liste à choix multiple »</title>
+
+  <p>
+   Pour les champs de type « Liste », si le champ est configuré avec une simple
+   liste d'options, la valeur doit être une chaîne tirée de la liste.
+  </p>
+
+   <listing>
+    <code>
+    "data": {
+       "<var>varname</var>": "Libellé 1",
+    }
+    </code>
+   </listing>
+
+   <p>
+    Si le champ est configuré pour tirer ses options depuis une source de
+    données, la valeur peut être l'identifiant d'une donnée structurée ou si la
+    donnée structurée complète est transmise, l'identifiant de la donnée dans
+    une clé suffixée de <code>_raw</code>, le libellé de la donnée dans la clé
+    normale et éventuellement la donnée structurée complète dans une clé
+    suffixée de <code>_structured</code>.
+   </p>
+
+    <listing>
+    <title>Identifiant d'une option</title>
+    <code>
+    "data": {
+       "<var>varname</var>": "1"
+    }
+    </code>
+    </listing>
+
+    <listing>
+    <title>Donnée structurée</title>
+    <code>
+    "data": {
+       "<var>varname</var>": "Libellé 1",
+       "<var>varname</var>_raw": "1",
+       "<var>varname</var>_structured": {
+          "id": "1",
+          "text": "Libellé 1",
+          "foo": "bar"
+       }
+    }
+    </code>
+    </listing>
+
+
+  <p>
+   Pour les champs de type « Liste à choix multiple », si le champ est
+   configuré avec une simple liste d'options, la valeur doit être une
+   liste de chaînes tirées de la liste.
+   </p>
+
+    <listing>
+    <code>
+    "data": {
+       "<var>varname</var>": ["Libellé 1", "Libellé 2"],
+    }
+    </code>
+    </listing>
+
+   <p>
+    Si le champ est configuré pour tirer ses options depuis une source de
+    données, la valeur peut être une liste d'identifiants ou,
+    si la donnée structurée complète est transmise, la liste des identifiants
+    de la donnée dans une clé suffixée de <code>_raw</code>, la liste des
+    libellés de la donnée dans la clé normale et éventuellement la liste des
+    données structurées complètes dans une clé suffixée de
+    <code>_structured</code>.
+   </p>
+
+    <listing>
+    <title>Liste d'identifiants d'options</title>
+    <code>
+    "data": {
+       "<var>varname</var>": ["1", "2"]
+    }
+    </code>
+    </listing>
+
+    <listing>
+    <title>Listes de données structurées</title>
+    <code>
+    "data": {
+       "<var>varname</var>": ["Libellé 1", "Libellé 2"],
+       "<var>varname</var>_raw": ["1", "2"],
+       "<var>varname</var>_structured": [
+         {
+            "id": "1",
+            "text": "Libellé 1",
+            "foo": "bar"
+         },
+         {
+            "id": "2",
+            "text": "Libellé 2",
+            "foo": "bar2"
+         }
+       ]
+    }
+    </code>
+    </listing>
+
+</section>
+
 </page>
-- 
2.20.1