From 55745c9a213f51109235dca5de915c7e712e366c Mon Sep 17 00:00:00 2001
From: Christophe Siraut <csiraut@entrouvert.com>
Date: Thu, 18 Apr 2019 11:52:09 +0200
Subject: [PATCH] translation update

---
 .../locale/fr/LC_MESSAGES/django.po           |   8 +-
 .../locale/fr/LC_MESSAGES/django.po           | 101 +++++++++---------
 hobo/locale/fr/LC_MESSAGES/django.po          |  30 +++++-
 3 files changed, 78 insertions(+), 61 deletions(-)

diff --git a/hobo/agent/authentic2/locale/fr/LC_MESSAGES/django.po b/hobo/agent/authentic2/locale/fr/LC_MESSAGES/django.po
index 5d519ff..6d1deb0 100644
--- a/hobo/agent/authentic2/locale/fr/LC_MESSAGES/django.po
+++ b/hobo/agent/authentic2/locale/fr/LC_MESSAGES/django.po
@@ -7,7 +7,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: hobo 0\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2019-01-04 11:26+0000\n"
+"POT-Creation-Date: 2019-04-18 11:41+0200\n"
 "PO-Revision-Date: 2016-01-23 15:06+0100\n"
 "Last-Translator: Frederic Peters <fpeters@entrouvert.com>\n"
 "Language: French\n"
@@ -34,15 +34,15 @@ msgstr "L'élément {0} est invalide: {1}"
 msgid "Role details (frontoffice)"
 msgstr "Détails du rôle, affichés en front-office"
 
-#: agent/authentic2/role_forms.py:84
+#: agent/authentic2/role_forms.py:85
 msgid "Emails"
 msgstr "Courriels"
 
-#: agent/authentic2/role_forms.py:87
+#: agent/authentic2/role_forms.py:88
 msgid "Emails must be separated by commas."
 msgstr "Les courriels doivent être séparés par des virgules."
 
-#: agent/authentic2/role_forms.py:90
+#: agent/authentic2/role_forms.py:91
 msgid "Emails to members"
 msgstr "Propager les courriels à tous les utilisateurs ayant ce rôle"
 
diff --git a/hobo/environment/locale/fr/LC_MESSAGES/django.po b/hobo/environment/locale/fr/LC_MESSAGES/django.po
index 5ca9b85..2235f36 100644
--- a/hobo/environment/locale/fr/LC_MESSAGES/django.po
+++ b/hobo/environment/locale/fr/LC_MESSAGES/django.po
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: PACKAGE VERSION\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2019-01-04 11:26+0000\n"
+"POT-Creation-Date: 2019-04-18 11:41+0200\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
@@ -18,165 +18,153 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 
-#: environment/forms.py:32 environment/models.py:67
+#: environment/forms.py:32 environment/models.py:77
 msgid "Template"
 msgstr "Modèle (template)"
 
-#: environment/models.py:26
+#: environment/models.py:31
 msgid "name"
 msgstr "nom"
 
-#: environment/models.py:27
+#: environment/models.py:32
 msgid "label"
 msgstr "label"
 
-#: environment/models.py:28
+#: environment/models.py:33
 msgid "value"
 msgstr "valeur"
 
-#: environment/models.py:30
+#: environment/models.py:35
 msgid "start with [ or { for a JSON document"
 msgstr "commencer par [ ou { pour du JSON"
 
-#: environment/models.py:63
+#: environment/models.py:73
 msgid "Title"
 msgstr "Titre"
 
-#: environment/models.py:64
+#: environment/models.py:74
 msgid "Slug"
 msgstr "Slug"
 
-#: environment/models.py:65
+#: environment/models.py:75
 msgid "Base URL"
 msgstr "URL de base"
 
-#: environment/models.py:66
+#: environment/models.py:76
 msgid "Secret Key"
 msgstr "Clé secrète"
 
-#: environment/models.py:68
+#: environment/models.py:78
 msgid "Secondary Service"
 msgstr "Service secondaire"
 
-#: environment/models.py:134
+#: environment/models.py:144
 msgid "This slug is already used. It must be unique."
 msgstr "Ce slug est déjà utilisé. Il doit être unique."
 
-#: environment/models.py:218
+#: environment/models.py:228
 msgid "Use as IdP"
 msgstr "Utiliser comme IdP"
 
-#: environment/models.py:222
+#: environment/models.py:232
 msgid "Authentic Identity Provider"
 msgstr "Fournisseur d'identités (IdP) Authentic"
 
-#: environment/models.py:223
+#: environment/models.py:233
 msgid "Authentic Identity Providers"
 msgstr "Fournisseurs d'identités (IdP) Authentic"
 
-#: environment/models.py:228
+#: environment/models.py:238
 msgid "Authentic"
 msgstr "Authentic"
 
-#: environment/models.py:233
+#: environment/models.py:243
 msgid "User Management"
 msgstr "Gestion des utilisateurs"
 
-#: environment/models.py:234
+#: environment/models.py:244
 msgid "Role Management"
 msgstr "Gestion des rôles"
 
-#: environment/models.py:246 environment/models.py:247
+#: environment/models.py:256 environment/models.py:257
 msgid "w.c.s. Web Forms"
 msgstr "Téléformulaires w.c.s."
 
-#: environment/models.py:252
+#: environment/models.py:262
 msgid "w.c.s."
 msgstr "w.c.s."
 
-#: environment/models.py:269 environment/models.py:270
-#: environment/models.py:275
+#: environment/models.py:279 environment/models.py:280
+#: environment/models.py:285
 msgid "Passerelle"
 msgstr "Passerelle"
 
-#: environment/models.py:292
+#: environment/models.py:302
 msgid "Combo Portal"
 msgstr "Portail Combo"
 
-#: environment/models.py:293
+#: environment/models.py:303
 msgid "Combo Portals"
 msgstr "Portails Combo"
 
-#: environment/models.py:298
+#: environment/models.py:308
 msgid "Combo"
 msgstr "Combo"
 
-#: environment/models.py:315 environment/models.py:316
+#: environment/models.py:325 environment/models.py:326
 msgid "Fargo document box"
 msgstr "Porte-documents Fargo"
 
-#: environment/models.py:321
+#: environment/models.py:331
 msgid "Fargo"
 msgstr "Fargo"
 
-#: environment/models.py:335
+#: environment/models.py:345
 msgid "Welco Multichannel Home"
 msgstr "Accueil multi-canal Welco"
 
-#: environment/models.py:356
+#: environment/models.py:366
 msgid "Site Application"
 msgstr "Application du site"
 
-#: environment/models.py:361
+#: environment/models.py:371
 msgid "Authentication Reverse Proxy"
 msgstr "Reverse Proxy authentifiant"
 
-#: environment/models.py:366
+#: environment/models.py:376
 msgid "mandayejs"
 msgstr "MandayeJS"
 
-#: environment/models.py:384 environment/models.py:385
+#: environment/models.py:394 environment/models.py:395
 msgid "Chrono Agendas"
 msgstr "Agendas Chrono"
 
-#: environment/models.py:390
+#: environment/models.py:400
 msgid "Chrono"
 msgstr "Chrono"
 
-#: environment/models.py:407
+#: environment/models.py:417
 msgid "Hobo Deployment Server"
 msgstr "Serveur de déploiement Hobo"
 
-#: environment/models.py:408
+#: environment/models.py:418
 msgid "Hobo Deployment Servers"
 msgstr "Serveurs de déploiement Hobo"
 
-#: environment/models.py:413
+#: environment/models.py:423
 msgid "Deployment Server"
 msgstr "Serveur de déploiement"
 
-#: environment/models.py:429
-msgid "Admins Emails"
-msgstr "Courriels des admins"
-
-#: environment/models.py:431 environment/models.py:432
-msgid "Piwik"
-msgstr "Piwik"
-
-#: environment/models.py:437
-msgid "piwik"
-msgstr "piwik"
-
-#: environment/models.py:452 environment/models.py:453
+#: environment/models.py:440 environment/models.py:441
 msgid "Announces Management"
 msgstr "Gestion des annonces"
 
-#: environment/models.py:458
+#: environment/models.py:446
 msgid "Corbo"
 msgstr "Corbo"
 
-#: environment/models.py:479 environment/models.py:480
-#: environment/models.py:485
+#: environment/models.py:467 environment/models.py:468
+#: environment/models.py:473
 msgid "Statistics"
 msgstr "Statistiques"
 
@@ -272,5 +260,14 @@ msgstr "Variable"
 msgid "Variables"
 msgstr "Variables"
 
+#~ msgid "Admins Emails"
+#~ msgstr "Courriels des admins"
+
+#~ msgid "Piwik"
+#~ msgstr "Piwik"
+
+#~ msgid "piwik"
+#~ msgstr "piwik"
+
 #~ msgid "Back to settings"
 #~ msgstr "Retour au paramètrage"
diff --git a/hobo/locale/fr/LC_MESSAGES/django.po b/hobo/locale/fr/LC_MESSAGES/django.po
index 0235ea2..f859848 100644
--- a/hobo/locale/fr/LC_MESSAGES/django.po
+++ b/hobo/locale/fr/LC_MESSAGES/django.po
@@ -7,7 +7,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: hobo 0\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2019-01-18 09:37+0000\n"
+"POT-Creation-Date: 2019-04-18 11:41+0200\n"
 "PO-Revision-Date: 2019-01-18 10:32+0100\n"
 "Last-Translator: Frederic Peters <fpeters@entrouvert.com>\n"
 "Language: French\n"
@@ -16,11 +16,11 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 
-#: emails/forms.py:22
+#: emails/forms.py:31
 msgid "Default From"
 msgstr "Expéditeur par défaut"
 
-#: emails/forms.py:23
+#: emails/forms.py:32
 msgid "Signature"
 msgstr "Signature"
 
@@ -35,6 +35,26 @@ msgstr "Courriels"
 msgid "Submit"
 msgstr "Valider"
 
+#: emails/validators.py:32 emails/validators.py:34
+#, python-format
+msgid "Error: %s"
+msgstr "Erreur: %s"
+
+#: emails/validators.py:39 emails/validators.py:43
+#, python-format
+msgid "Error while connecting to %(server)s: %(msg)s"
+msgstr "Erreur pendant la connexion à %(server)s: %(msg)s"
+
+#: emails/validators.py:48
+#, python-format
+msgid "Email address not found on %s"
+msgstr "Adreese email non trouvée sur %s"
+
+#: emails/validators.py:65
+#, python-format
+msgid "No matching SPF record for %s"
+msgstr "Il n'y a pas d'enregistrement SPF correspondant pour %s"
+
 #: emails/views.py:29
 msgid ""
 "Emails settings have been updated. It will take a few seconds to be "
@@ -215,11 +235,11 @@ msgstr ""
 msgid "options"
 msgstr "options"
 
-#: settings.py:154
+#: settings.py:156
 msgid "User Portal"
 msgstr "Portail usager"
 
-#: settings.py:155
+#: settings.py:157
 msgid "Agent Portal"
 msgstr "Portail agent"
 
-- 
2.20.1